Subject: Re: [PATCH v7 06/15] bugreport: add compiler info

From: Emily Shaffer <[email-masked]>
Date: Fri, 21 Feb 2020 16:04:38 -0800

On Fri, Feb 21, 2020 at 04:22:43PM +0100, Johannes Schindelin wrote:
> Hi Emily,
> 
> On Thu, 20 Feb 2020, Emily Shaffer wrote:
> 
> > On Thu, Feb 20, 2020 at 11:33:05PM +0100, Johannes Schindelin wrote:
> > > Hi Emily,
> > >
> > > On Wed, 19 Feb 2020, Emily Shaffer wrote:
> > >
> > > >   #ifdef __GLIBC__
> > > >   #include <gnu/libc-version.h>
> > > >   #endif
> > > >
> > > >   static inline void get_compiler_info(struct strbuf *info)
> > > >   {
> > > >   	#ifdef __GLIBC__
> > > > 	strbuf_addf(info, "glibc: %s\n", gnu_get_libc_version());
> > > > 	#endif
> > > >
> > > > 	#ifdef __GNUC__
> > > > 	strbuf_addf(info, "gnuc: %d.%d\n", __GNUC__, __GNUC_MINOR__);
> > > > 	#endif
> > > >
> > > > 	#ifdef _MSC_VER
> > > > 	strbuf_addf(info, "msc runtime: %s\n", some_msc_info());
> > >
> > > You could do it this way right away:
> > >
> > > 	strbuf_addf(info, "MSVC version: %d.%d\n",
> > > 		    _MSC_VER / 100, _MSC_VER % 100);
> > >
> > > Note: this is _not_ the MSVC _runtime_ version, but really the compiler
> > > version.
> > >
> > > You could also use _MSC_FULL_VER, which is a bit more complete.
> >
> > Sorry, but I'm not comfortable sending code I can't check for myself
> > (and already muscle-memoried into my format-patch/send-email workflow).
> > If you send a scissors I can roll it into the series with your SOB.
> 
> But you can check it yourself! I worked _really_ hard on that Azure
> Pipeline backing the PR builds at https://github.com/git/git. _REALLY_
> hard. You might just as well reap the benefits so that I did not spend all
> of that time and sweat and stress in vain...

I thought a bit about this. From your Github-using point of view, "just
check my Pipeline" sounds like "just look at one more thing". From my
format-patch using point of view, "just check my Pipeline" sounds like
"ugh, I have to add this remote again... I don't have a fork already?
How do I make that? Or is my fork just 6 months behind? How do I open a
PR again? Yeesh."

So I did what any good developer who's supposed to be writing
semi-annual performance reviews would, and wrote a first pass at script
with this brand new fancy 'gh' thing (which is, by the way, clearly not
intended for scripting): https://github.com/nasamuffin/quimby. Maybe
someone will find it useful.

I'll try and add your MSC snippet for the next rollup.

 - Emily

P.S. You can thank Jonathan Nieder for the name, as I asked for ideas
and he said "Wikipedia tells me Chief Quimby gives Inspector Gadget
something to read that later self-destructs." :P